import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCursor;
import com.mongodb.MongoClient;
import com.mongodb.MongoClientURI;
import com.mongodb.gridfs.GridFS;
import com.mongodb.gridfs.GridFSDBFile;
import com.mongodb.gridfs.GridFSInputFile;

public class MongoSafeImage {

  public static byte[] LoadImage(String filePath) throws Exception {
    File file = new File(filePath);
    int size = (int) file.length();
    byte[] buffer = new byte[size];
    FileInputStream in = new FileInputStream(file);
    in.read(buffer);
    in.close();
    return buffer;
  }
  
  private static void listAllImages(DB db) {
    GridFS gfsPhoto = new GridFS(db);
    DBCursor cursor = gfsPhoto.getFileList();
    while (cursor.hasNext()) {
        System.out.println(cursor.next());
    }
}

  public static void main(String[] args) throws Exception {
    byte[] imageBytes = LoadImage("Images/a.jpg");
    MongoClient mongoClient = new MongoClient(new MongoClientURI("mongodb://admin:admin@ds155428.mlab.com:55428/amu"));
        
    DB db = mongoClient.getDB("amu");
    
    listAllImages(db);

    GridFS fs = new GridFS(db);
    GridFSInputFile in = fs.createFile(imageBytes);
    in.setFilename("nowy");
    in.save();

    GridFSDBFile out = fs.findOne("nowy");
    FileOutputStream outputImage = new FileOutputStream("Images/out.bmp");
    out.writeTo(outputImage);
    outputImage.close();
    
    fs.remove(fs.findOne("nowy"));
  }
}